// Program tworzy dwoch potomkow, i za pomoca laczy nienazwanych 
// wykonywany jest ciag polecen ls | grep WZOR | wc -l, nazwa WZOR 
// przekazywana jest jako argument wywolania 
// (c) Kacper Kulczycki 2007
//****************************************************************************
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "err.h"
//****************************************************************************
int main(int argc, char *argv[])
{
 if (argc != 2) 
        {
        fatal("Brak zdefiniowanych parametrow dla %s!!!", argv[0]);
        }
 int pipe_desc[2];
 char pipe_write_descriptor[1024];
 if (pipe (pipe_desc) == -1) 
	{
	syserr("Blad w pipe!!!\n");
	}
 switch (fork()) 
	{
    	case -1:
      		syserr("Blad podczas fork!!!\n");
    	case 0: //potomek
      		if (close (pipe_desc[0]) == -1) //nie bedzie czytal
			{
			syserr("Blad podczas close(pipe_desc[0])!!!\n");
			}
      		sprintf(pipe_write_descriptor, "%d", pipe_desc[1]);
      		execl("./child1", "child1", argv[1], pipe_write_descriptor,NULL);
      		syserr("Blad podczas execl(child1)!!!\n");
    	default: //rodzic
      		if (close (pipe_desc[1]) == -1) //nie bedzie pisal
			{
			syserr("Blad podczas close (pipe_desc[1])!!!\n");
      			}
 		if (close (0) == -1) //zamkniecie stdin
                      	{
                       	syserr("Blad podczas close(0)!!!\n");
                       	}
		if (dup(pipe_desc[0]) != 0) //duplikacja konca "wejsciowego" w miejsce stdin
			{    
			syserr("Blad podczas dup(pipe_desc[0])!!!");
			}
		 if (close (pipe_desc[0]) == -1)// zamkniecie zbednego juz wejscia - bo zastapione stdin
                        {
                        syserr("Blad podczas close(pipe_desc[0])!!!\n");
                        }
		execlp("wc", "wc","-l",NULL);
        		syserr("Blad podczas execlp(wc)!!!\n");
		if (close (0) == -1)
                        {
                        syserr("Blad podczas close(0)!!!\n");
                        }
		if (wait (0) == -1)
        		{
			syserr("Blad podczas wait!!!\n");
			}
		exit(0);
	}
exit(0);
}

